package esami

import (
	"math/rand"
	"testing"
)


func TestSemplicePerMedia(t *testing.T) {
	var inputDaTestare Voti
	inputDaTestare = []int{18, 20}
	v := Media(inputDaTestare)
	if  v != 19.0 {
		t.Error("Expected 19 got ", v)
	}
}

func TestMediaSenzaVoti(t *testing.T) {
	v := Media([]int{})
	if v != 0.0 {
		t.Error("On empty slice, expected 0 got ", v)
	}
}

func TestMediaLode(t *testing.T) {
	v := Media([]int{32, 30, 18})
	if v != 26.0 {
		t.Error("On empty slice, expected 0 got ", v)
	}
}

type testCase struct {
	voti Voti
	mediaAttesa float64
}

func TestMediaGenerale(t *testing.T) {
	var test []testCase = []testCase{
		{[]int{18, 20}, 19.0},
		{[]int{18, 18, 18}, 18.0},
		{[]int{32, 32, 32, 32, 32, 32}, 30.0},
		{[]int{32, 30, 32, 30, 32, 32}, 30.0},
		{[]int{32}, 30.0},
		{[]int{}, 0.0},
	}

	for _, caso := range test {
		mediaOttenuta := Media(caso.voti)
		if mediaOttenuta != caso.mediaAttesa {
			t.Error("Su input ", caso.voti, " ho ottenuto ", mediaOttenuta, " mentre mi aspettavo ", caso.mediaAttesa)
		}
	}
}

func TestMediaACaso(t *testing.T) {
	for i := 0; i < 100; i++ {
		voto := 18 + rand.Intn(30-18+1)
		mediaOttenuta := Media([]int{voto})
		if  mediaOttenuta != float64(voto) {
			t.Error("Su input singolo ", voto, " ho ottenuto media ", mediaOttenuta)
		}
	}
}
